(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/coercion'), require('@angular/core'), require('@angular/forms'), require('@ng-tangram/components/forms'), require('rxjs/observable/defer'), require('rxjs/observable/merge'), require('rxjs/operators'), require('rxjs/Subject'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/cdk/coercion', '@angular/core', '@angular/forms', '@ng-tangram/components/forms', 'rxjs/observable/defer', 'rxjs/observable/merge', 'rxjs/operators', 'rxjs/Subject', '@angular/common'], factory) :
    (factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.checkbox = {}),global.ng.cdk.coercion,global.ng.core,global.ng.forms,global.nt.components.forms,global.Rx.observable.defer,global.Rx.observable.merge,global.Rx.operators,global.Rx.Subject,global.ng.common));
}(this, (function (exports,coercion,core,forms,forms$1,defer,merge,operators,Subject,common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var /** @type {?} */ uniqueId = 0;
    /**
     * @template T
     */
    var  /**
     * @template T
     */
    NtCheckboxChange = /** @class */ (function () {
        function NtCheckboxChange(source, checked) {
            this.source = source;
            this.checked = checked;
        }
        return NtCheckboxChange;
    }());
    /**
     * @template T
     */
    var NtCheckboxComponent = /** @class */ (function () {
        function NtCheckboxComponent(tabIndex, ngControl) {
            this.ngControl = ngControl;
            this.id = "nt-checkbox-" + uniqueId++;
            this._disabled = false;
            this._readonly = false;
            this._checked = false;
            this.change = new core.EventEmitter();
            this._onChange = function () { };
            this._onTouched = function () { };
            if (this.ngControl) {
                this.ngControl.valueAccessor = this;
            }
            this.tabIndex = parseInt(tabIndex) || 0;
        }
        Object.defineProperty(NtCheckboxComponent.prototype, "value", {
            get: /**
             * @return {?}
             */
            function () { return this._value; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._value = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtCheckboxComponent.prototype, "disabled", {
            get: /**
             * @return {?}
             */
            function () { return this._disabled; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._disabled = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtCheckboxComponent.prototype, "readonly", {
            get: /**
             * @return {?}
             */
            function () { return this._readonly; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._readonly = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtCheckboxComponent.prototype, "checked", {
            get: /**
             * @return {?}
             */
            function () { return this._checked; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._checked = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} value
         * @return {?}
         */
        NtCheckboxComponent.prototype.writeValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._checked = !!value;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        NtCheckboxComponent.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this._onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        NtCheckboxComponent.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this._onTouched = fn;
        };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        NtCheckboxComponent.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
        function (isDisabled) {
            this.disabled = isDisabled;
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtCheckboxComponent.prototype._onInputClick = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            event.stopPropagation();
            if (!this.disabled) {
                this._checked = !this._checked;
                this._onTouched();
                this._emitChangeEvent();
            }
        };
        /**
         * @return {?}
         */
        NtCheckboxComponent.prototype._emitChangeEvent = /**
         * @return {?}
         */
        function () {
            var /** @type {?} */ event = new NtCheckboxChange(this, this.checked);
            this._onChange(this.checked);
            this.change.emit(event);
        };
        NtCheckboxComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-checkbox',
                        encapsulation: core.ViewEncapsulation.None,
                        template: "<label class=\"nt-checkbox-layout\"> <div class=\"nt-checkbox-input-container\"> <input class=\"cdk-visually-hidden\" type=\"checkbox\" [tabIndex]=\"tabIndex\" [checked]=\"checked\" [disabled]=\"disabled\" (click)=\"_onInputClick($event)\"> <div class=\"nt-checkbox-input\"></div> </div> <span class=\"nt-checkbox-label\"> <ng-content></ng-content> </span> </label> ",
                        providers: [
                            { provide: forms$1.NtFormFieldControl, useExisting: NtCheckboxComponent }
                        ],
                        host: {
                            'class': 'nt-checkbox',
                            '[class.disabled]': 'disabled'
                        }
                    },] },
        ];
        /** @nocollapse */
        NtCheckboxComponent.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Attribute, args: ['tabindex',] },] },
            { type: forms.NgControl, decorators: [{ type: core.Self }, { type: core.Optional },] },
        ]; };
        NtCheckboxComponent.propDecorators = {
            "value": [{ type: core.Input },],
            "disabled": [{ type: core.Input },],
            "readonly": [{ type: core.Input },],
            "checked": [{ type: core.Input },],
            "change": [{ type: core.Output },],
        };
        return NtCheckboxComponent;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    /**
     * @return {?}
     */
    function getNtCheckboxGroupNonFunctionValueError() {
        return Error('`compareWith` must be a function.');
    }
    var /** @type {?} */ uniqueId$1 = 0;
    /**
     * @template T
     */
    var NtCheckboxGroupComponent = /** @class */ (function (_super) {
        __extends(NtCheckboxGroupComponent, _super);
        function NtCheckboxGroupComponent(_ngZone, _changeDetectorRef, ngControl) {
            var _this = _super.call(this) || this;
            _this._ngZone = _ngZone;
            _this._changeDetectorRef = _changeDetectorRef;
            _this.ngControl = ngControl;
            _this.id = "nt-checkbox-group-" + uniqueId$1++;
            _this._destroy = new Subject.Subject();
            _this._disabled = false;
            _this._readonly = false;
            _this._required = false;
            _this._compareWith = function (o1, o2) { return o1 === o2; };
            _this.checkedChanges = defer.defer(function () {
                if (_this.checkboxes) {
                    return merge.merge.apply(void 0, _this.checkboxes.map(function (item) { return item.change; }));
                }
                return _this._ngZone.onStable
                    .asObservable()
                    .pipe(operators.take(1), operators.switchMap(function () { return _this.checkedChanges; }));
            });
            /**
             * Emits when the value changes (either due to user input or programmatic change).
             */
            _this._onChange = function () { };
            _this._onTouched = function () { };
            if (_this.ngControl) {
                _this.ngControl.valueAccessor = _this;
            }
            return _this;
        }
        Object.defineProperty(NtCheckboxGroupComponent.prototype, "value", {
            get: /**
             * @return {?}
             */
            function () { return this._value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtCheckboxGroupComponent.prototype, "disabled", {
            get: /**
             * @return {?}
             */
            function () { return this._disabled; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._disabled = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtCheckboxGroupComponent.prototype, "required", {
            get: /**
             * @return {?}
             */
            function () { return this._required; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._required = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtCheckboxGroupComponent.prototype, "readonly", {
            get: /**
             * @return {?}
             */
            function () { return this._readonly; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._readonly = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtCheckboxGroupComponent.prototype, "compareWith", {
            set: /**
             * @param {?} fn
             * @return {?}
             */
            function (fn) {
                if (typeof fn !== 'function') {
                    throw getNtCheckboxGroupNonFunctionValueError();
                }
                else {
                    this._compareWith = fn;
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NtCheckboxGroupComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.checkboxes.changes.pipe(operators.startWith(null), operators.takeUntil(this._destroy)).subscribe(function () {
                _this._initializeChecked();
            });
            this.checkedChanges.pipe(operators.takeUntil(this._destroy)).subscribe(function () {
                _this._setValues();
            });
        };
        /**
         * @return {?}
         */
        NtCheckboxGroupComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this._destroy.next();
            this._destroy.complete();
        };
        /**
         * @param {?} value
         * @return {?}
         */
        NtCheckboxGroupComponent.prototype.writeValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (this.checkboxes) {
                this._setCheckedByValue(value);
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        NtCheckboxGroupComponent.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this._onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        NtCheckboxGroupComponent.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this._onTouched = fn;
        };
        /**
         * @return {?}
         */
        NtCheckboxGroupComponent.prototype.focus = /**
         * @return {?}
         */
        function () {
            if (!this.disabled) {
                this._onTouched();
            }
        };
        /**
         * @return {?}
         */
        NtCheckboxGroupComponent.prototype._initializeChecked = /**
         * @return {?}
         */
        function () {
            var _this = this;
            Promise.resolve().then(function () {
                _this._setCheckedByValue(_this.ngControl ? _this.ngControl.value : _this.value);
            });
        };
        /**
         * @param {?} value
         * @return {?}
         */
        NtCheckboxGroupComponent.prototype._setCheckedByValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            var _this = this;
            if (value) {
                this._value = value;
                this.checkboxes.forEach(function (item) { return item.checked = false; });
                value.forEach(function (val) { return _this._checkedValue(val); });
                this._changeDetectorRef.markForCheck();
            }
        };
        /**
         * @param {?} value
         * @return {?}
         */
        NtCheckboxGroupComponent.prototype._checkedValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            var _this = this;
            var /** @type {?} */ correspondingItem = this.checkboxes.find(function (item) {
                try {
                    return item.value != null && _this._compareWith(item.value, value);
                }
                catch (/** @type {?} */ error) {
                    if (core.isDevMode()) {
                        console.warn(error);
                    }
                    return false;
                }
            });
            if (correspondingItem) {
                correspondingItem.checked = true;
            }
            return correspondingItem;
        };
        /**
         * @return {?}
         */
        NtCheckboxGroupComponent.prototype._setValues = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this._value = [];
            this.checkboxes.forEach(function (item) {
                if (item.checked && !!item.value) {
                    _this._value.push(item.value);
                }
            });
            this._onChange(this._value);
            this._onTouched();
            this._changeDetectorRef.markForCheck();
        };
        NtCheckboxGroupComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-checkbox-group',
                        template: '<ng-content></ng-content>',
                        encapsulation: core.ViewEncapsulation.None,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        providers: [
                            { provide: forms$1.NtFormFieldControl, useExisting: NtCheckboxGroupComponent }
                        ],
                        host: {
                            class: 'nt-checkbox-group nt-form-control'
                        }
                    },] },
        ];
        /** @nocollapse */
        NtCheckboxGroupComponent.ctorParameters = function () { return [
            { type: core.NgZone, },
            { type: core.ChangeDetectorRef, },
            { type: forms.NgControl, decorators: [{ type: core.Self }, { type: core.Optional },] },
        ]; };
        NtCheckboxGroupComponent.propDecorators = {
            "disabled": [{ type: core.Input },],
            "required": [{ type: core.Input },],
            "readonly": [{ type: core.Input },],
            "checkboxes": [{ type: core.ContentChildren, args: [NtCheckboxComponent,] },],
            "compareWith": [{ type: core.Input },],
        };
        return NtCheckboxGroupComponent;
    }(forms$1.NtFormFieldControl));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var NtCheckboxModule = /** @class */ (function () {
        function NtCheckboxModule() {
        }
        NtCheckboxModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        exports: [NtCheckboxComponent, NtCheckboxGroupComponent],
                        declarations: [NtCheckboxComponent, NtCheckboxGroupComponent],
                    },] },
        ];
        return NtCheckboxModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */

    exports.NtCheckboxChange = NtCheckboxChange;
    exports.NtCheckboxComponent = NtCheckboxComponent;
    exports.getNtCheckboxGroupNonFunctionValueError = getNtCheckboxGroupNonFunctionValueError;
    exports.NtCheckboxGroupComponent = NtCheckboxGroupComponent;
    exports.NtCheckboxModule = NtCheckboxModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=checkbox.umd.js.map
