import { Component, ViewEncapsulation, ElementRef, Input, ViewChild, TemplateRef, NgModule } from '@angular/core';
import { CdkOverlayOrigin } from '@angular/cdk/overlay';
import { NtOverlayComponent, NtOverlayModule } from '@ng-tangram/components/core';
import { CommonModule } from '@angular/common';
import { NtDropdownModule } from '@ng-tangram/components/dropdown';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NtPopoverPaneComponent {
    constructor() { }
}
NtPopoverPaneComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-popover-pane, [nt-popover-pane]',
                template: `
    <ng-content></ng-content>
  `,
                encapsulation: ViewEncapsulation.None
            },] },
];
/** @nocollapse */
NtPopoverPaneComponent.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NtPopoverComponent {
    /**
     * @param {?} _elementRef
     */
    constructor(_elementRef) {
        this._elementRef = _elementRef;
        this._title = '';
        this.position = 'top';
        this.origin = new CdkOverlayOrigin(this._elementRef);
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set title(value) { this._title = value; }
    /**
     * @return {?}
     */
    get title() { return this._title; }
    /**
     * @param {?} value
     * @return {?}
     */
    set template(value) { this._template = value; }
    /**
     * @return {?}
     */
    get template() { return this._template; }
    /**
     * @param {?} value
     * @return {?}
     */
    set _default(value) {
        if (value instanceof TemplateRef) {
            this._template = value;
        }
        else {
            this._title = value;
            this._template = null;
        }
    }
}
NtPopoverComponent.decorators = [
    { type: Component, args: [{
                selector: '[nt-popover]',
                template: "<ng-content></ng-content> <nt-overlay [origin]=\"origin\" [position]=\"position\" trigger=\"click\" arrow> <div class=\"nt-popover\"> <div class=\"nt-popover-title\" *ngIf=\"template\"><ng-container *ngTemplateOutlet=\"template\"></ng-container></div> <div class=\"nt-popover-title\" *ngIf=\"!template\" [innerHtml]=\"title\"></div> <div class=\"nt-popover-pane\"> <ng-content select=\"nt-popover-pane\"></ng-content> </div> </div> </nt-overlay> ",
                encapsulation: ViewEncapsulation.None,
                host: {
                    '(click)': 'overlay.click()'
                }
            },] },
];
/** @nocollapse */
NtPopoverComponent.ctorParameters = () => [
    { type: ElementRef, },
];
NtPopoverComponent.propDecorators = {
    "title": [{ type: Input },],
    "template": [{ type: Input },],
    "_default": [{ type: Input, args: ['nt-popover',] },],
    "position": [{ type: Input },],
    "overlay": [{ type: ViewChild, args: [NtOverlayComponent,] },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NtPopoverModule {
}
NtPopoverModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, NtOverlayModule, NtDropdownModule],
                exports: [NtPopoverComponent, NtPopoverPaneComponent],
                declarations: [NtPopoverComponent, NtPopoverPaneComponent]
            },] },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

export { NtPopoverModule, NtPopoverComponent, NtPopoverPaneComponent };
//# sourceMappingURL=popover.js.map
